-- copy all globals into locals, some locals are prefixed with a G to reduce name clashes
local coroutine,package,string,table,math,io,os,debug,assert,dofile,error,_G,getfenv,getmetatable,ipairs,Gload,loadfile,loadstring,next,pairs,pcall,print,rawequal,rawget,rawset,select,setfenv,setmetatable,tonumber,tostring,type,unpack,_VERSION,xpcall,module,require=coroutine,package,string,table,math,io,os,debug,assert,dofile,error,_G,getfenv,getmetatable,ipairs,load,loadfile,loadstring,next,pairs,pcall,print,rawequal,rawget,rawset,select,setfenv,setmetatable,tonumber,tostring,type,unpack,_VERSION,xpcall,module,require

local pack=require("wetgenes.pack")
local wwin=require("wetgenes.win")
local wstr=require("wetgenes.string")
local tardis=require("wetgenes.tardis")	-- matrix/vector math


module(...)
modname=(...)

bake=function(oven,game)
	local game=game or {}
	game.oven=oven
	
	game.modname=modname
	

	local cake=oven.cake
	local opts=oven.opts
	local canvas=oven.cake.canvas
	local font=canvas.font
	local flat=canvas.flat
	local gl=oven.gl
	
	
	-- a suboven
--	game.subs=require("wetgenes.gamecake.oven").bake({
--		master=oven,
--	})

	game.layout=cake.layouts.create{}
	
	game.input={}
	game.input.volatile={}
	game.page="menu"
	game.wait=60
	
	
	local cards=oven.rebake("dike.cards")
	local stacks=oven.rebake("dike.stacks")
	local items=oven.rebake("dike.items")
	
	
game.loads=function()

	oven.cake.sounds.loads({
		"sfx/test",
	})

--	oven.cake.sounds.load_speak("Welcome to the world of tomorrow!","welcome")

	oven.cake.fonts.loads({1}) -- load 1st builtin font, a basic 8x8 font
	
	oven.cake.images.loads({
	})
	
	do
		local t={}
		for _,c in ipairs{"c","d","h","s"} do
			for i=1,13 do
				t[#t+1]={cards.filename(c,i),1,1,0.5,0.5}
			end
		end
		t[#t+1]={cards.filename("b",1),1,1,0.5,0.5}
		t[#t+1]={cards.filename("b",2),1,1,0.5,0.5}
		
--		print(wstr.dump(t))
		oven.cake.sheets.loads_and_chops(t)
	end

		oven.cake.sheets.loads_and_chops({
			{"parts/undo",1,1,0.5,0.5},
		})


end
		
game.setup=function()

	game.loads()
	
	game.last=nil
	game.now=nil
	game.next=nil
	
	game.next=oven.rebake("dike.game_play")
	
	
	game.change()
end

function game.change()

-- handle oven changes

	if game.next then
	
		if game.now and game.now.clean then
			game.now.clean()
		end
		
		game.last=game.now
		game.now=game.next
		game.next=nil
		
		if game.now and game.now.setup then
			game.now.setup()
		end
		
	end
	
end		

game.clean=function()

	if game.now and game.now.clean then
		game.now.clean()
	end

end

game.msg=function(m)
--	print(wstr.dump(m))
		
--	game.js.msg(m)

	if m.xraw and m.yraw then	-- we need to fix raw x,y numbers
		m.x,m.y=game.layout.xyscale(m.xraw,m.yraw)	-- local coords, 0,0 is center of screen
		m.x=m.x+(720/2)
		m.y=m.y+(480/2)
	end

	if game.now and game.now.msg then
		game.now.msg(m)
	end
	
end

game.update=function()

	game.change()

	for i,v in pairs(game.input.volatile) do
		game.input[i]=v 
	end
	game.input.volatile={}

	if game.now and game.now.update then
		game.now.update()
	end

--	game.play.update(oven)

end

game.draw=function()
--print("draw")

	
	game.layout.apply( opts.width,opts.height,1/4,opts.height*4 )
	canvas.gl_default() -- reset gl oven

	gl.ClearColor(pack.argb4_pmf4(0xf030))
	gl.Clear(gl.COLOR_BUFFER_BIT+gl.DEPTH_BUFFER_BIT)


	font.set(cake.fonts.get(1)) -- default font
	font.set_size(32,0) -- 32 pixels high

	if game.now and game.now.draw then
		game.now.draw()
	end
	
end
		
	return game
end

