-- copy all globals into locals, some locals are prefixed with a G to reduce name clashes
local coroutine,package,string,table,math,io,os,debug,assert,dofile,error,_G,getfenv,getmetatable,ipairs,Gload,loadfile,loadstring,next,pairs,pcall,print,rawequal,rawget,rawset,select,setfenv,setmetatable,tonumber,tostring,type,unpack,_VERSION,xpcall,module,require=coroutine,package,string,table,math,io,os,debug,assert,dofile,error,_G,getfenv,getmetatable,ipairs,load,loadfile,loadstring,next,pairs,pcall,print,rawequal,rawget,rawset,select,setfenv,setmetatable,tonumber,tostring,type,unpack,_VERSION,xpcall,module,require


local function print(...) _G.print(...) end

local wstr=require("wetgenes.string")
local pack=require("wetgenes.pack")

module(...)
modname=(...)

bake=function(oven,gui)

	gui=gui or {} 
	gui.modname=modname

	local game=oven.rebake("dike.game")

	gui.pages={} -- put functions to fill in pages in here

	function gui.setup()
	
		gui.master=oven.rebake("wetgenes.gamecake.widgets").setup({})
	
		gui.page("play")
	end
	
	function gui.hooks(act,w,dat)
		if act=="click" then
			if w.id then
				if     w.id=="undo"  then
	print("undo")
				elseif w.id=="score" then
	print("score")
				elseif w.id=="reset"  then
	print("reset")
					game.next=oven.rebake("dike.game_play")
				end
			end
		end
	end
	
	function gui.pages.play(master)

		local top=master:add({hx=720,hy=480,class="fill",font="Vera",text_size=16})
		
		top:add_border({hx=240,hy=24,px=4,py=0,color=0xffcccccc,text="Undo",hooks=gui.hooks,id="undo"})
		top:add_border({hx=240,hy=24,px=4,py=0,color=0xffcccccc,text="Score",hooks=gui.hooks,id="score"})
		top:add_border({hx=240,hy=24,px=4,py=0,color=0xffcccccc,text="Reset",hooks=gui.hooks,id="reset"})

--[[
		top:add({sy=440,sx=720})
		local bot=top:add({sy=40,sx=720,mx=720,class="flow"})
		bot:add({sx=100,text="undo",color=0xffffffff,id="undo",hooks=hooks})
		bot:add({sx=720-200,text="score",id="score",hooks=hooks,text_color=0xffffffff,text_color_shadow=0xff000000})
		bot:add({sx=100,text="menu",color=0xffffffff,id="menu",hooks=hooks})
]]
		
	end
	
	function gui.page(pname)
	
		gui.master:clean_all()
		
		if pname then
			local f=gui.pages[pname]
			if f then
				f(gui.master) -- pass in the master so we could fill up other widgets
			end
		end

		gui.master:layout()
		
	end

	function gui.clean()

		gui.master=nil
	
	end
	
	function gui.update()
	
		gui.master:update()

	end
	
	function gui.msg(m)

		gui.master:msg(m)

	end

	function gui.draw()
	
		gui.master:draw()

	end
	
	return gui
end

